/* aine-query */

/* aine-query is a non-interactive interface to the aine interpreter.
* It demonstrates the functionality of aine at it's simplest level
* and can be used with either piped text or the text as argv elements

License: GPL v2 (see license.txt for details)
					Aine-cli
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	Check COPYING file for full license.

aine-query by Gilbert Ashley
(amigo@ibiblio.org www.amigolinux.org)
aine-query is written using code from aine, aine-cgi or the aine tester following
the hints given in the file readme4developers.txt.
Most of the good code and ideas are from David Calinski and Jacco Bikker.
Many other people also contributed to the project.
See the COPYING, README and COPYRIGHT files for more information.
*/


#include "aine.h"

void print_usage (char *s) {
	printf ("Aine-cli, usage:\n");
	printf ("%s TEXT\n", s);
	printf ("Where \"TEXT\" is the query string.\n");
	printf ("Or: echo TEXT | %s\n", s);
	return;
}

int main (int argc, char* argv[])
{
	char *input = (char*) malloc (sizeof(char) * MAX_AINE_INPUT);
	char *output = (char*) malloc (sizeof(char) * 4096);
	char *buf;
	
	register int y;
	
	buf = (char*) malloc (sizeof(char) * MAX_OUTPUT);
	if (initialize ("data/aine-query.ini")) return 1;
		
	loadvars ("data/aine-query-defvars.txt");
	
	if (argc >= 2) {
		if (!(strcmp (argv[1], "-h")) || !(strcmp (argv[1], "--help"))) {
			print_usage(argv[0]);
			return 1;
		} else {
			for (y = 1; y < argc; y++) {
				strcat (buf, argv[y]);
				strcat (buf, " ");
			}
		}
		strcpy (input, buf);
	} else {
		fgets (input, MAX_AINE_INPUT, stdin);
	}
	
	spacetrim (input);
	strcpy (output, respond (input));
	printf ("%s\n", output);
	
	deinitialize();
	free (input);
	free (output); 
	free (buf);
	
	exit (0);
}
